/* Written by Yong Li, Depeng Liu                                       */
/* Copyright (c) 2016                  	                               */
/* This program is free software: you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
 /* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* This program is distributed in the hope that it will be useful,      */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License    */
/* along with this program.  If not, see <http://www.gnu.org/licenses/>.*/

package cn.ac.ios.learner.multiplicity;

import java.io.ByteArrayOutputStream;
import java.util.ArrayList;
import java.util.List;

import cn.ac.ios.automata.words.ContextWord;
import cn.ac.ios.automata.words.Word;
import cn.ac.ios.table.ObservationRow;
import cn.ac.ios.table.ObservationTableAbstract;
import cn.ac.ios.table.ObservationTablePrinterBoolean;

public class ObservationTableMult extends ObservationTableAbstract {
	//size of upper table
	private int l;
	
	protected ObservationTableMult(ContextWord contextWord) {
		super(contextWord);
		l = 1;
		//1. upperTable add the epsilon row
		upperTable.add(new ObservationRowMult(contextWord.getEmptyWord()));
		//2. columns add the epsilon column
//		columns.add(contextWord.getEmptyWord());
	}

	@Override
	public ObservationRow getUnclosedLowerRow() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public Word getInconsistentColumn() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public ObservationRow addLowerRow(Word word) {
		ObservationRow row = new ObservationRowMult(word);
		lowerTable.add(row);
		return row;
	}

	@Override
	public ObservationRow addUpperRow(Word word) {
		ObservationRow row = new ObservationRowMult(word);
		upperTable.add(row);
		l ++;
		return row;
	}
	
	public String toString() {
        ByteArrayOutputStream out = new ByteArrayOutputStream();
        try {
        	ObservationTablePrinterHelper.print(this, out);
            return out.toString();
        } catch (Exception e) {
            return "ERROR";
        }
	}

	public int getsize(){
		return l;
	}
}
