/* Written by Yong Li, Depeng Liu                                       */
/* Copyright (c) 2016                  	                               */
/* This program is free software: you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
 /* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* This program is distributed in the hope that it will be useful,      */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License    */
/* along with this program.  If not, see <http://www.gnu.org/licenses/>.*/

package cn.ac.ios.learner.nlstar;

import java.util.List;

import cn.ac.ios.automata.words.Word;
import cn.ac.ios.table.HashableValue;
import cn.ac.ios.table.ObservationRowAbstract;

public class ObservationRowNLStar extends ObservationRowAbstract {

	protected ObservationRowNLStar(Word word) {
		super(word);
	}
	
	public boolean equals(Object o) {
		if(! (o instanceof ObservationRowNLStar)) {
			return false;
		}
		ObservationRowNLStar other = (ObservationRowNLStar)o;
		return word.equals(other.word); // one row one word
	}
	
	// Row1 covers Row2 if Row2(i) implies Row1(i)
	protected boolean covers(ObservationRowNLStar other) {
		List<HashableValue> otherValues = other.getValues(); 
		assert values.size() == otherValues.size();
		for(int valNr = 0; valNr < values.size(); valNr ++) {
			if((Boolean)otherValues.get(valNr).get() && (! (Boolean)values.get(valNr).get())) {
				return false;
			}
		}
		return true;
	}

}
